part of tecfy_corev2_client_package;

class DropdownComponenet extends StatefulWidget {
  final String? label;
  final String? description;
  final bool isRequired;
  final bool readOnly;
  final String? initalValue;
  final List<Map<String, dynamic>>? options;
  final String idProperty;
  final String displayProperty;
  final Map<String, dynamic>? rootData;
  final Entity? rootEntity;
  final void Function(String?)? onChanged;
  DropdownComponenet({
    this.label,
    this.description,
    this.options,
    this.initalValue,
    this.onChanged,
    this.rootData,
    this.rootEntity,
    this.isRequired = false,
    this.readOnly = false,
    this.idProperty = '_id',
    this.displayProperty = 'name',
    Key? key,
  }) : super(key: key);
  @override
  _DropdownComponenetState createState() => _DropdownComponenetState();
}

class _DropdownComponenetState extends TecfyState<DropdownComponenet> {
  List<Map<String, dynamic>>? _data;
  String? _value;
  @override
  void initState() {
    _value = widget.initalValue;
    _data = widget.options;
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return _data == null
        ? TecfyText('${trans('Loading')}..')
        : Tooltip(
            message: widget.description ?? '',
            child: DropdownButtonFormField<String>(
              isExpanded: true,
              decoration: InputDecoration(
                  helperText: widget.description,
                  labelText: widget.label == null
                      ? null
                      : '${trans(widget.label)}${widget.isRequired ? '*' : ''}'),
              value:
                  (_data?.any((e) => e[widget.idProperty] == _value) ?? false)
                      ? _value
                      : null,
              onChanged: widget.readOnly
                  ? null
                  : (v) {
                      _value = v;
                      widget.onChanged?.call(v);
                      setState(() {});
                    },
              items: (_data
                      ?.map<DropdownMenuItem<String>>(
                          (item) => DropdownMenuItem(
                                child: TecfyText(
                                  item[widget.displayProperty] ??
                                          item['display'] ??
                                          item['name'] is Map
                                      ? item['name'][LocalConfigService
                                          .languagePrefix
                                          .toLowerCase()]
                                      : item['name'].toString() ??
                                          item['nameAr'] ??
                                          item['nameEn'] ??
                                          'N/A',
                                  style: TextStyle(color: Colors.black),
                                ),
                                value: item[widget.idProperty],
                              ))
                      .toList() ??
                  [])
                ..add(_value == null
                    ? DropdownMenuItem(
                        child: TecfyText(trans('Click To Select'),
                            style: TextStyle(color: Colors.black38)),
                      )
                    : DropdownMenuItem(
                        child: TecfyText('غير محدد',
                            style: TextStyle(color: Colors.black38)),
                        value: null,
                      )),
            ),
          );
  }
}
